// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ProfileClient is the client API for Profile service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ProfileClient interface {
	//
	// Проверка прав на доступ администратора и возврат активного keyspace
	Auth(ctx context.Context, in *api.Empty, opts ...grpc.CallOption) (*Keyspace, error)
	//
	// Получить список пользовательских профилей (значение заданное в поле id объекта запроса является фильтром для поиска по имени почте ии телефону).
	ListProfiles(ctx context.Context, in *api.SearchFilter, opts ...grpc.CallOption) (Profile_ListProfilesClient, error)
	//
	// Мониторить изменения профиля FreejeProfile.id
	MonitorProfile(ctx context.Context, in *FreejeProfile, opts ...grpc.CallOption) (Profile_MonitorProfileClient, error)
	//
	// Обновить данные по профилю и возвратить его текущее состояние
	UpdateProfile(ctx context.Context, in *FreejeProfile, opts ...grpc.CallOption) (*FreejeProfile, error)
	ChargeProfile(ctx context.Context, in *Charge, opts ...grpc.CallOption) (*AccountBalance, error)
	UnlockFinanceOperation(ctx context.Context, in *api.FinanceOperation, opts ...grpc.CallOption) (*api.FinanceOperation, error)
	// Получить данные документа
	GetDocumentData(ctx context.Context, in *DidDocument, opts ...grpc.CallOption) (*DidDocument, error)
	// Получить список активных документов в профиле (без данных)
	GetProfileDocuments(ctx context.Context, in *FreejeProfile, opts ...grpc.CallOption) (Profile_GetProfileDocumentsClient, error)
	//
	// Добавить в аккаунт все телефыоны указанные в phone
	LinkProfilePhones(ctx context.Context, in *FreejeProfile, opts ...grpc.CallOption) (*FreejeProfile, error)
	//
	// Получить отчет по финансовым операциям
	BuildFinanceReport(ctx context.Context, in *api.ReportRequestOptions, opts ...grpc.CallOption) (Profile_BuildFinanceReportClient, error)
}

type profileClient struct {
	cc grpc.ClientConnInterface
}

func NewProfileClient(cc grpc.ClientConnInterface) ProfileClient {
	return &profileClient{cc}
}

func (c *profileClient) Auth(ctx context.Context, in *api.Empty, opts ...grpc.CallOption) (*Keyspace, error) {
	out := new(Keyspace)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Profile/Auth", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) ListProfiles(ctx context.Context, in *api.SearchFilter, opts ...grpc.CallOption) (Profile_ListProfilesClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[0], "/com.freeje.api.admin.Profile/ListProfiles", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileListProfilesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_ListProfilesClient interface {
	Recv() (*FreejeProfile, error)
	grpc.ClientStream
}

type profileListProfilesClient struct {
	grpc.ClientStream
}

func (x *profileListProfilesClient) Recv() (*FreejeProfile, error) {
	m := new(FreejeProfile)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) MonitorProfile(ctx context.Context, in *FreejeProfile, opts ...grpc.CallOption) (Profile_MonitorProfileClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[1], "/com.freeje.api.admin.Profile/MonitorProfile", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileMonitorProfileClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_MonitorProfileClient interface {
	Recv() (*FreejeProfile, error)
	grpc.ClientStream
}

type profileMonitorProfileClient struct {
	grpc.ClientStream
}

func (x *profileMonitorProfileClient) Recv() (*FreejeProfile, error) {
	m := new(FreejeProfile)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) UpdateProfile(ctx context.Context, in *FreejeProfile, opts ...grpc.CallOption) (*FreejeProfile, error) {
	out := new(FreejeProfile)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Profile/UpdateProfile", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) ChargeProfile(ctx context.Context, in *Charge, opts ...grpc.CallOption) (*AccountBalance, error) {
	out := new(AccountBalance)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Profile/ChargeProfile", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) UnlockFinanceOperation(ctx context.Context, in *api.FinanceOperation, opts ...grpc.CallOption) (*api.FinanceOperation, error) {
	out := new(api.FinanceOperation)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Profile/UnlockFinanceOperation", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) GetDocumentData(ctx context.Context, in *DidDocument, opts ...grpc.CallOption) (*DidDocument, error) {
	out := new(DidDocument)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Profile/GetDocumentData", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) GetProfileDocuments(ctx context.Context, in *FreejeProfile, opts ...grpc.CallOption) (Profile_GetProfileDocumentsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[2], "/com.freeje.api.admin.Profile/GetProfileDocuments", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileGetProfileDocumentsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_GetProfileDocumentsClient interface {
	Recv() (*DidDocument, error)
	grpc.ClientStream
}

type profileGetProfileDocumentsClient struct {
	grpc.ClientStream
}

func (x *profileGetProfileDocumentsClient) Recv() (*DidDocument, error) {
	m := new(DidDocument)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *profileClient) LinkProfilePhones(ctx context.Context, in *FreejeProfile, opts ...grpc.CallOption) (*FreejeProfile, error) {
	out := new(FreejeProfile)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Profile/LinkProfilePhones", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *profileClient) BuildFinanceReport(ctx context.Context, in *api.ReportRequestOptions, opts ...grpc.CallOption) (Profile_BuildFinanceReportClient, error) {
	stream, err := c.cc.NewStream(ctx, &Profile_ServiceDesc.Streams[3], "/com.freeje.api.admin.Profile/BuildFinanceReport", opts...)
	if err != nil {
		return nil, err
	}
	x := &profileBuildFinanceReportClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Profile_BuildFinanceReportClient interface {
	Recv() (*api.FinanceOperation, error)
	grpc.ClientStream
}

type profileBuildFinanceReportClient struct {
	grpc.ClientStream
}

func (x *profileBuildFinanceReportClient) Recv() (*api.FinanceOperation, error) {
	m := new(api.FinanceOperation)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// ProfileServer is the server API for Profile service.
// All implementations should embed UnimplementedProfileServer
// for forward compatibility
type ProfileServer interface {
	//
	// Проверка прав на доступ администратора и возврат активного keyspace
	Auth(context.Context, *api.Empty) (*Keyspace, error)
	//
	// Получить список пользовательских профилей (значение заданное в поле id объекта запроса является фильтром для поиска по имени почте ии телефону).
	ListProfiles(*api.SearchFilter, Profile_ListProfilesServer) error
	//
	// Мониторить изменения профиля FreejeProfile.id
	MonitorProfile(*FreejeProfile, Profile_MonitorProfileServer) error
	//
	// Обновить данные по профилю и возвратить его текущее состояние
	UpdateProfile(context.Context, *FreejeProfile) (*FreejeProfile, error)
	ChargeProfile(context.Context, *Charge) (*AccountBalance, error)
	UnlockFinanceOperation(context.Context, *api.FinanceOperation) (*api.FinanceOperation, error)
	// Получить данные документа
	GetDocumentData(context.Context, *DidDocument) (*DidDocument, error)
	// Получить список активных документов в профиле (без данных)
	GetProfileDocuments(*FreejeProfile, Profile_GetProfileDocumentsServer) error
	//
	// Добавить в аккаунт все телефыоны указанные в phone
	LinkProfilePhones(context.Context, *FreejeProfile) (*FreejeProfile, error)
	//
	// Получить отчет по финансовым операциям
	BuildFinanceReport(*api.ReportRequestOptions, Profile_BuildFinanceReportServer) error
}

// UnimplementedProfileServer should be embedded to have forward compatible implementations.
type UnimplementedProfileServer struct {
}

func (UnimplementedProfileServer) Auth(context.Context, *api.Empty) (*Keyspace, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Auth not implemented")
}
func (UnimplementedProfileServer) ListProfiles(*api.SearchFilter, Profile_ListProfilesServer) error {
	return status.Errorf(codes.Unimplemented, "method ListProfiles not implemented")
}
func (UnimplementedProfileServer) MonitorProfile(*FreejeProfile, Profile_MonitorProfileServer) error {
	return status.Errorf(codes.Unimplemented, "method MonitorProfile not implemented")
}
func (UnimplementedProfileServer) UpdateProfile(context.Context, *FreejeProfile) (*FreejeProfile, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateProfile not implemented")
}
func (UnimplementedProfileServer) ChargeProfile(context.Context, *Charge) (*AccountBalance, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ChargeProfile not implemented")
}
func (UnimplementedProfileServer) UnlockFinanceOperation(context.Context, *api.FinanceOperation) (*api.FinanceOperation, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UnlockFinanceOperation not implemented")
}
func (UnimplementedProfileServer) GetDocumentData(context.Context, *DidDocument) (*DidDocument, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetDocumentData not implemented")
}
func (UnimplementedProfileServer) GetProfileDocuments(*FreejeProfile, Profile_GetProfileDocumentsServer) error {
	return status.Errorf(codes.Unimplemented, "method GetProfileDocuments not implemented")
}
func (UnimplementedProfileServer) LinkProfilePhones(context.Context, *FreejeProfile) (*FreejeProfile, error) {
	return nil, status.Errorf(codes.Unimplemented, "method LinkProfilePhones not implemented")
}
func (UnimplementedProfileServer) BuildFinanceReport(*api.ReportRequestOptions, Profile_BuildFinanceReportServer) error {
	return status.Errorf(codes.Unimplemented, "method BuildFinanceReport not implemented")
}

// UnsafeProfileServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ProfileServer will
// result in compilation errors.
type UnsafeProfileServer interface {
	mustEmbedUnimplementedProfileServer()
}

func RegisterProfileServer(s grpc.ServiceRegistrar, srv ProfileServer) {
	s.RegisterService(&Profile_ServiceDesc, srv)
}

func _Profile_Auth_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).Auth(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Profile/Auth",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).Auth(ctx, req.(*api.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_ListProfiles_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.SearchFilter)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).ListProfiles(m, &profileListProfilesServer{stream})
}

type Profile_ListProfilesServer interface {
	Send(*FreejeProfile) error
	grpc.ServerStream
}

type profileListProfilesServer struct {
	grpc.ServerStream
}

func (x *profileListProfilesServer) Send(m *FreejeProfile) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_MonitorProfile_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(FreejeProfile)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).MonitorProfile(m, &profileMonitorProfileServer{stream})
}

type Profile_MonitorProfileServer interface {
	Send(*FreejeProfile) error
	grpc.ServerStream
}

type profileMonitorProfileServer struct {
	grpc.ServerStream
}

func (x *profileMonitorProfileServer) Send(m *FreejeProfile) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_UpdateProfile_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FreejeProfile)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).UpdateProfile(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Profile/UpdateProfile",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).UpdateProfile(ctx, req.(*FreejeProfile))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_ChargeProfile_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Charge)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).ChargeProfile(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Profile/ChargeProfile",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).ChargeProfile(ctx, req.(*Charge))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_UnlockFinanceOperation_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.FinanceOperation)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).UnlockFinanceOperation(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Profile/UnlockFinanceOperation",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).UnlockFinanceOperation(ctx, req.(*api.FinanceOperation))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_GetDocumentData_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DidDocument)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).GetDocumentData(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Profile/GetDocumentData",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).GetDocumentData(ctx, req.(*DidDocument))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_GetProfileDocuments_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(FreejeProfile)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).GetProfileDocuments(m, &profileGetProfileDocumentsServer{stream})
}

type Profile_GetProfileDocumentsServer interface {
	Send(*DidDocument) error
	grpc.ServerStream
}

type profileGetProfileDocumentsServer struct {
	grpc.ServerStream
}

func (x *profileGetProfileDocumentsServer) Send(m *DidDocument) error {
	return x.ServerStream.SendMsg(m)
}

func _Profile_LinkProfilePhones_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FreejeProfile)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProfileServer).LinkProfilePhones(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Profile/LinkProfilePhones",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProfileServer).LinkProfilePhones(ctx, req.(*FreejeProfile))
	}
	return interceptor(ctx, in, info, handler)
}

func _Profile_BuildFinanceReport_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.ReportRequestOptions)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ProfileServer).BuildFinanceReport(m, &profileBuildFinanceReportServer{stream})
}

type Profile_BuildFinanceReportServer interface {
	Send(*api.FinanceOperation) error
	grpc.ServerStream
}

type profileBuildFinanceReportServer struct {
	grpc.ServerStream
}

func (x *profileBuildFinanceReportServer) Send(m *api.FinanceOperation) error {
	return x.ServerStream.SendMsg(m)
}

// Profile_ServiceDesc is the grpc.ServiceDesc for Profile service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Profile_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.Profile",
	HandlerType: (*ProfileServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Auth",
			Handler:    _Profile_Auth_Handler,
		},
		{
			MethodName: "UpdateProfile",
			Handler:    _Profile_UpdateProfile_Handler,
		},
		{
			MethodName: "ChargeProfile",
			Handler:    _Profile_ChargeProfile_Handler,
		},
		{
			MethodName: "UnlockFinanceOperation",
			Handler:    _Profile_UnlockFinanceOperation_Handler,
		},
		{
			MethodName: "GetDocumentData",
			Handler:    _Profile_GetDocumentData_Handler,
		},
		{
			MethodName: "LinkProfilePhones",
			Handler:    _Profile_LinkProfilePhones_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "ListProfiles",
			Handler:       _Profile_ListProfiles_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "MonitorProfile",
			Handler:       _Profile_MonitorProfile_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetProfileDocuments",
			Handler:       _Profile_GetProfileDocuments_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "BuildFinanceReport",
			Handler:       _Profile_BuildFinanceReport_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "admin/profile.proto",
}
